from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Directory, Int, Float, Boolean

Centreseq_Core_V0_1_0 = CommandToolBuilder(tool="centreseq_core", base_command=["centreseq", "core"], inputs=[ToolInput(tag="in_fast_a_dir", input_type=File(optional=True), prefix="--fasta-dir", doc=InputDocumentation(doc="Path to directory containing *.fasta files for\ninput to the core pipeline  [required]")), ToolInput(tag="in_outdir", input_type=Directory(optional=True), prefix="--outdir", doc=InputDocumentation(doc="Root directory to store all output files. If\nthis directory already exists, the pipeline\nwill attempt to skip the Prokka step by reading\nin the existing Prokka output directory, but\nwill overwrite all other existing result files.\n[required]")), ToolInput(tag="in_n_cpu", input_type=Int(optional=True), prefix="--n-cpu", doc=InputDocumentation(doc="Number of CPUs to dedicate to parallelizable\nsteps of the pipeline. Will take all available\nCPUs - 1 by default.")), ToolInput(tag="in_n_cpu_me_do_id", input_type=Int(optional=True), prefix="--n-cpu-medoid", doc=InputDocumentation(doc="Number of CPUs for the representative medoid\npicking step (if enabled). You will need\nsubstantial RAM per CPU.")), ToolInput(tag="in_min_seq_id", input_type=Float(optional=True), prefix="--min-seq-id", doc=InputDocumentation(doc="Sets the mmseqs cluster parameter '--min-seq-\nid'. Defaults to 0.95.")), ToolInput(tag="in_coverage_length", input_type=Float(optional=True), prefix="--coverage-length", doc=InputDocumentation(doc="Sets the mmseqs cluster coverage parameter '-c'\ndirectly. Defaults to 0.95, which is the\nrecommended setting.")), ToolInput(tag="in_me_do_id_reps_eqs", input_type=Boolean(optional=True), prefix="--medoid-repseqs", doc=InputDocumentation(doc="This setting will identify the representative\nmedoid nucleotide sequence for each core\ncluster. Enabling this will increase\ncomputation time considerably. Note that this\nparameter has no effect on the number of core\nclusters detected.")), ToolInput(tag="in_pairwise", input_type=Boolean(optional=True), prefix="--pairwise", doc=InputDocumentation(doc="Generate pairwise comparisons of all core\ngenomes. This setting allows for viewing an\ninteractive network chart which visualizes core\ngenome relatedness.")), ToolInput(tag="in_verbose", input_type=Boolean(optional=True), prefix="--verbose", doc=InputDocumentation(doc="Set this flag to enable more verbose logging."))], outputs=[ToolOutput(tag="out_outdir", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_outdir", type_hint=File()), doc=OutputDocumentation(doc="Root directory to store all output files. If\nthis directory already exists, the pipeline\nwill attempt to skip the Prokka step by reading\nin the existing Prokka output directory, but\nwill overwrite all other existing result files.\n[required]"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Centreseq_Core_V0_1_0().translate("wdl", allow_empty_container=True)

